Loading...
Searching...
No Matches
pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

OURCVFHEstimation estimates the Oriented, Unique and Repetable Clustered Viewpoint Feature Histogram (CVFH) descriptor for a given point cloud dataset given XYZ data and normals, as presented in: More...

`#include <pcl/features/our_cvfh.h>`

Inheritance diagram for pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< OURCVFHEstimation< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const OURCVFHEstimation< PointInT, PointNT, PointOutT > >
using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut
using | KdTreePtr = typename pcl::search::Search< PointNormal >::Ptr
using | PointInTPtr = typename pcl::PointCloud< PointInT >::Ptr
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| OURCVFHEstimation ()
| Empty constructor.
Eigen::Matrix4f | createTransFromAxes (Eigen::Vector3f &evx, Eigen::Vector3f &evy, Eigen::Vector3f &evz, Eigen::Affine3f &transformPC, Eigen::Matrix4f &center_mat)
| Creates an affine transformation from the RF axes.
void | computeRFAndShapeDistribution (PointInTPtr &processed, PointCloudOut &output, std::vector< pcl::PointIndices > &cluster_indices)
| Computes SGURF and the shape distribution based on the selected SGURF.
bool | sgurf (Eigen::Vector3f &centroid, Eigen::Vector3f &normal_centroid, PointInTPtr &processed, std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &transformations, PointInTPtr &grid, pcl::PointIndices &indices)
| Computes SGURF.
void | filterNormalsWithHighCurvature (const pcl::PointCloud< PointNT > &cloud, pcl::Indices &indices_to_use, pcl::Indices &indices_out, pcl::Indices &indices_in, float threshold)
| Removes normals with high curvature caused by real edges or noisy data.
void | setViewPoint (float vpx, float vpy, float vpz)
| Set the viewpoint.
void | setRadiusNormals (float radius_normals)
| Set the radius used to compute normals.
void | getViewPoint (float &vpx, float &vpy, float &vpz)
| Get the viewpoint.
void | getCentroidClusters (std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > &centroids)
| Get the centroids used to compute different CVFH descriptors.
void | getCentroidNormalClusters (std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > &centroids)
| Get the normal centroids used to compute different CVFH descriptors.
void | setClusterTolerance (float d)
| Sets max.
void | setEPSAngleThreshold (float d)
| Sets max.
void | setCurvatureThreshold (float d)
| Sets curvature threshold for removing normals.
void | setMinPoints (std::size_t min)
| Set minimum amount of points for a cluster to be considered.
void | setNormalizeBins (bool normalize)
| Sets whether the signatures should be normalized or not.
void | getClusterIndices (std::vector< pcl::PointIndices > &indices)
| Gets the indices of the original point cloud used to compute the signatures.
void | getClusterAxes (std::vector< short > &cluster_axes)
| Gets the number of non-disambiguable axes that correspond to each centroid.
void | setRefineClusters (float rc)
| Sets the refinement factor for the clusters.
void | getTransforms (std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &trans)
| Returns the transformations aligning the point cloud to the corresponding SGURF.
void | getValidTransformsVec (std::vector< bool > &valid)
| Returns a boolean vector indicating of the transformation obtained by getTransforms() represents a valid SGURF.
void | setAxisRatio (float f)
| Sets the min axis ratio between the SGURF axes to decide if disambiguition is feasible.
void | setMinAxisValue (float f)
| Sets the min disambiguition axis value to generate several SGURFs for the cluster when disambiguition is difficult.
void | compute (PointCloudOut &output)
| Overloaded computed method from pcl::Feature.
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset.
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset.
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Attributes

std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > | centroids_dominant_orientations_
| Centroids that were used to compute different OUR-CVFH descriptors.
std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > | dominant_normals_
| Normal centroids that were used to compute different OUR-CVFH descriptors.
std::vector< pcl::PointIndices > | clusters_
| Indices to the points representing the stable clusters.
std::vector< short > | cluster_axes_
| Mapping from clusters to OUR-CVFH descriptors.
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset.
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Detailed Description

template<typename PointInT, typename PointNT, typename PointOutT = pcl::VFHSignature308>
class pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >

OURCVFHEstimation estimates the Oriented, Unique and Repetable Clustered Viewpoint Feature Histogram (CVFH) descriptor for a given point cloud dataset given XYZ data and normals, as presented in:

- OUR-CVFH – Oriented, Unique and Repeatable Clustered Viewpoint Feature Histogram for Object Recognition and 6DOF Pose Estimation A. Aldoma, F. Tombari, R.B. Rusu and M. Vincze DAGM-OAGM 2012 Graz, Austria The suggested PointOutT is pcl::VFHSignature308.

Author
  Aitor Aldoma

Definition at line 59 of file our_cvfh.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

using pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::ConstPtr = shared_ptr<const OURCVFHEstimation<PointInT, PointNT, PointOutT> >

Definition at line 63 of file our_cvfh.h.

## KdTreePtr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

using pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::KdTreePtr = typename pcl::search::Search<PointNormal>::Ptr

Definition at line 73 of file our_cvfh.h.

## PointCloudOut

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

using pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 72 of file our_cvfh.h.

## PointInTPtr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

using pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::PointInTPtr = typename pcl::PointCloud<PointInT>::Ptr

Definition at line 74 of file our_cvfh.h.

## Ptr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

using pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::Ptr = shared_ptr<OURCVFHEstimation<PointInT, PointNT, PointOutT> >

Definition at line 62 of file our_cvfh.h.

## Constructor & Destructor Documentation

## OURCVFHEstimation()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::OURCVFHEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 76 of file our_cvfh.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_, pcl::Feature< PointInT, PointOutT >::k_, and pcl::Feature< PointInT, PointOutT >::search_radius_.

## Member Function Documentation

## compute()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute | ( | PointCloudOut & | output | ) |

Overloaded computed method from pcl::Feature.

Parameters

  [out] | output | the resultant point cloud model dataset containing the estimated features

Definition at line 53 of file our_cvfh.hpp.

## computeRFAndShapeDistribution()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution | ( | PointInTPtr & | processed,
|  | PointCloudOut & | output,
|  | std::vector< pcl::PointIndices > & | cluster_indices
| ) |  |

Computes SGURF and the shape distribution based on the selected SGURF.

Parameters

  [in] | processed | the input cloud
  [out] | output | the resulting signature
  [in] | cluster_indices | the indices of the stable cluster

Definition at line 381 of file our_cvfh.hpp.

References pcl::getMaxDistance(), and pcl::transformPointCloud().

## createTransFromAxes()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

Eigen::Matrix4f pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::createTransFromAxes | ( | Eigen::Vector3f & | evx,
|  | Eigen::Vector3f & | evy,
|  | Eigen::Vector3f & | evz,
|  | Eigen::Affine3f & | transformPC,
|  | Eigen::Matrix4f & | center_mat
| ) |  |

inline

Creates an affine transformation from the RF axes.

Parameters

  [in] | evx | the x-axis
  [in] | evy | the y-axis
  [in] | evz | the z-axis
  [out] | transformPC | the resulting transformation
  [in] | center_mat | 4x4 matrix concatenated to the resulting transformation

Definition at line 97 of file our_cvfh.h.

## filterNormalsWithHighCurvature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature | ( | const pcl::PointCloud< PointNT > & | cloud,
|  | pcl::Indices & | indices_to_use,
|  | pcl::Indices & | indices_out,
|  | pcl::Indices & | indices_in,
|  | float | threshold
| ) |  |

Removes normals with high curvature caused by real edges or noisy data.

Parameters

  [in] | cloud | pointcloud to be filtered
  [in] | indices_to_use |
  [out] | indices_out | the indices of the points with higher curvature than threshold
  [out] | indices_in | the indices of the remaining points after filtering
  [in] | threshold | threshold value for curvature

Definition at line 168 of file our_cvfh.hpp.

References pcl::PointCloud< PointT >::size().

## getCentroidClusters()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidClusters | ( | std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > & | centroids | ) |

inline

Get the centroids used to compute different CVFH descriptors.

Parameters

  [out] | centroids | vector to hold the centroids

Definition at line 191 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::centroids_dominant_orientations_.

## getCentroidNormalClusters()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidNormalClusters | ( | std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > & | centroids | ) |

inline

Get the normal centroids used to compute different CVFH descriptors.

Parameters

  [out] | centroids | vector to hold the normal centroids

Definition at line 201 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::dominant_normals_.

## getClusterAxes()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterAxes | ( | std::vector< short > & | cluster_axes | ) |

inline

Gets the number of non-disambiguable axes that correspond to each centroid.

Parameters

  [out] | cluster_axes | vector mapping each centroid to the number of signatures

Definition at line 266 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::cluster_axes_.

## getClusterIndices()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterIndices | ( | std::vector< pcl::PointIndices > & | indices | ) |

inline

Gets the indices of the original point cloud used to compute the signatures.

Parameters

  [out] | indices | vector of point indices

Definition at line 257 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::clusters_.

## getTransforms()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getTransforms | ( | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | trans | ) |

inline

Returns the transformations aligning the point cloud to the corresponding SGURF.

Parameters

  [out] | trans | vector of transformations

Definition at line 284 of file our_cvfh.h.

## getValidTransformsVec()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getValidTransformsVec | ( | std::vector< bool > & | valid | ) |

inline

Returns a boolean vector indicating of the transformation obtained by getTransforms() represents a valid SGURF.

Parameters

  [out] | valid | vector of booleans

Definition at line 294 of file our_cvfh.h.

## getViewPoint()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getViewPoint | ( | float & | vpx,
|  | float & | vpy,
|  | float & | vpz
| ) |  |

inline

Get the viewpoint.

Parameters

  [out] | vpx | the X coordinate of the viewpoint
  [out] | vpy | the Y coordinate of the viewpoint
  [out] | vpz | the Z coordinate of the viewpoint

Definition at line 180 of file our_cvfh.h.

## setAxisRatio()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setAxisRatio | ( | float | f | ) |

inline

Sets the min axis ratio between the SGURF axes to decide if disambiguition is feasible.

Parameters

  [in] | f | the ratio between axes

Definition at line 303 of file our_cvfh.h.

## setClusterTolerance()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setClusterTolerance | ( | float | d | ) |

inline

Sets max.

Euclidean distance between points to be added to the cluster

Parameters

  [in] | d | the maximum Euclidean distance

Definition at line 212 of file our_cvfh.h.

## setCurvatureThreshold()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setCurvatureThreshold | ( | float | d | ) |

inline

Sets curvature threshold for removing normals.

Parameters

  [in] | d | the curvature threshold

Definition at line 230 of file our_cvfh.h.

## setEPSAngleThreshold()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setEPSAngleThreshold | ( | float | d | ) |

inline

Sets max.

deviation of the normals between two points so they can be clustered together

Parameters

  [in] | d | the maximum deviation

Definition at line 221 of file our_cvfh.h.

## setMinAxisValue()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setMinAxisValue | ( | float | f | ) |

inline

Sets the min disambiguition axis value to generate several SGURFs for the cluster when disambiguition is difficult.

Parameters

  [in] | f | the min axis value

Definition at line 312 of file our_cvfh.h.

## setMinPoints()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setMinPoints | ( | std::size_t | min | ) |

inline

Set minimum amount of points for a cluster to be considered.

Parameters

  [in] | min | the minimum amount of points to be set

Definition at line 239 of file our_cvfh.h.

## setNormalizeBins()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setNormalizeBins | ( | bool | normalize | ) |

inline

Sets whether the signatures should be normalized or not.

Parameters

  [in] | normalize | true if normalization is required, false otherwise

Definition at line 248 of file our_cvfh.h.

## setRadiusNormals()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setRadiusNormals | ( | float | radius_normals | ) |

inline

Set the radius used to compute normals.

Parameters

  [in] | radius_normals | the radius

Definition at line 169 of file our_cvfh.h.

## setRefineClusters()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setRefineClusters | ( | float | rc | ) |

inline

Sets the refinement factor for the clusters.

Parameters

  [in] | rc | the factor used to decide if a point is used to estimate a stable cluster

Definition at line 275 of file our_cvfh.h.

## setViewPoint()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setViewPoint | ( | float | vpx,
|  | float | vpy,
|  | float | vpz
| ) |  |

inline

Set the viewpoint.

Parameters

  [in] | vpx | the X coordinate of the viewpoint
  [in] | vpy | the Y coordinate of the viewpoint
  [in] | vpz | the Z coordinate of the viewpoint

Definition at line 158 of file our_cvfh.h.

## sgurf()

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::sgurf | ( | Eigen::Vector3f & | centroid,
|  | Eigen::Vector3f & | normal_centroid,
|  | PointInTPtr & | processed,
|  | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | transformations,
|  | PointInTPtr & | grid,
|  | pcl::PointIndices & | indices
| ) |  |

Computes SGURF.

Parameters

  [in] | centroid | the centroid of the cluster
  [in] | normal_centroid | the average of the normals
  [in] | processed | the input cloud
  [out] | transformations | the transformations aligning the cloud to the SGURF axes
  [out] | grid | the cloud transformed internally
  [in] | indices | the indices of the stable cluster

Definition at line 198 of file our_cvfh.hpp.

References pcl::demeanPointCloud(), pcl::getMaxDistance(), pcl::PointIndices::indices, and pcl::transformPointCloud().

## Member Data Documentation

## centroids_dominant_orientations_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<Eigen::Vector3f, Eigen::aligned_allocator<Eigen::Vector3f> > pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::centroids_dominant_orientations_

protected

Centroids that were used to compute different OUR-CVFH descriptors.

Definition at line 394 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidClusters().

## cluster_axes_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<short> pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::cluster_axes_

protected

Mapping from clusters to OUR-CVFH descriptors.

Definition at line 400 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterAxes().

## clusters_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<pcl::PointIndices> pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::clusters_

protected

Indices to the points representing the stable clusters.

Definition at line 398 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterIndices().

## dominant_normals_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<Eigen::Vector3f, Eigen::aligned_allocator<Eigen::Vector3f> > pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::dominant_normals_

protected

Normal centroids that were used to compute different OUR-CVFH descriptors.

Definition at line 396 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidNormalClusters().

The documentation for this class was generated from the following files:

- pcl/features/our_cvfh.h
- pcl/features/impl/our_cvfh.hpp